VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Temperature Watch"
   ClientHeight    =   2880
   ClientLeft      =   150
   ClientTop       =   840
   ClientWidth     =   6015
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2880
   ScaleWidth      =   6015
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Left            =   5400
      Top             =   960
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   5280
      Top             =   2160
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.Label lblSymF 
      BackStyle       =   0  'Transparent
      Caption         =   "F"
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   36
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00C00000&
      Height          =   855
      Left            =   5280
      TabIndex        =   3
      Top             =   1440
      Width           =   735
   End
   Begin VB.Label lblSymC 
      BackStyle       =   0  'Transparent
      Caption         =   "C"
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   36
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00C00000&
      Height          =   855
      Left            =   5280
      TabIndex        =   2
      Top             =   120
      Width           =   735
   End
   Begin VB.Label lblTempF 
      Alignment       =   1  'Right Justify
      BackStyle       =   0  'Transparent
      Caption         =   "-999.9"
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   72
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00C00000&
      Height          =   1335
      Left            =   240
      TabIndex        =   1
      Top             =   1320
      Width           =   4815
   End
   Begin VB.Label lblTempC 
      Alignment       =   1  'Right Justify
      BackStyle       =   0  'Transparent
      Caption         =   "-999.9"
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   72
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00C00000&
      Height          =   1335
      Left            =   240
      TabIndex        =   0
      Top             =   0
      Width           =   4815
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileConnect 
         Caption         =   "&Connect..."
      End
      Begin VB.Menu mnuFileDisconnect 
         Caption         =   "&Disconnect"
      End
      Begin VB.Menu mnuFileSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const MyName As String = "Temperature Watch"
Const UpdateTime = 50

Public bs1Open As Boolean
Public bs1PortNum As Byte

Dim bs1Buffer As String
Dim bs1IORegs(2) As Byte                                ' DIRS, PINS (out), PINS (in)
Dim bs1ByteRegs(13) As Byte
Dim bs1WordRegs(6) As Long

Dim tempC As Single
Dim tempF As Single


Private Sub Form_Load()

  Dim idx As Byte
  Dim fNum As Integer
  Dim fName As String
  
  bs1Buffer = vbNullString                              ' initialize buffer
  mnuFileDisconnect_Click                               ' make sure port is closed
  
  For idx = 0 To 2                                      ' clear BS1 register values
    bs1IORegs(idx) = 0
  Next
  For idx = 0 To 13
    bs1ByteRegs(idx) = 0
  Next
  For idx = 0 To 6
    bs1WordRegs(idx) = 0
  Next
  Update_Display
  
  fNum = FreeFile
  fName = App.Path & "\" & App.Title & ".set"
  If FileExists(fName) Then
    Open fName For Binary As #fNum
    Get #fNum, 1, bs1PortNum
    Close fNum
  Else
    bs1PortNum = 1
  End If
  
End Sub

Private Sub Form_Unload(Cancel As Integer)

  Dim setting(1) As Byte
  Dim fNum As Integer
  Dim fName As String
  Dim theForm As Form
  
  fNum = FreeFile
  fName = App.Path & "\" & App.Title & ".set"
  Open fName For Binary As #fNum
  Put #fNum, 1, bs1PortNum
  Close fNum
  
  ' don't leave the comm port open!
  If (MSComm1.PortOpen = True) Then
    MSComm1.RTSEnable = False
    MSComm1.PortOpen = False
  End If

  ' unload all forms
  For Each theForm In Forms
    If theForm.Name <> Me.Name Then
      Unload theForm
      Set theForm = Nothing
    End If
  Next theForm

End Sub

Private Sub mnuFileConnect_Click()

  ' open com port dialog
   With frmCommSelect
     .updnComPort.Value = bs1PortNum
     .Show vbModal, Me
   End With
   If (bs1Open = True) Then
     On Error GoTo No_Connect
     With MSComm1
       .CommPort = bs1PortNum
       .DTREnable = True
       .RTSEnable = False
       .Settings = "4800,n,8,1"
       .RThreshold = 1
       .PortOpen = True
     End With
     Me.Caption = MyName & " - COM" & Trim(Str(bs1PortNum))
     mnuFileConnect.Enabled = False
     mnuFileDisconnect.Enabled = True
     Timer1.Interval = UpdateTime
     Timer1.Enabled = True
     bs1Buffer = vbNullString
   End If
   On Error GoTo 0
   Exit Sub
   
No_Connect:
  Dim response
  
  ' display port connection problem
  response = MsgBox("Error: Could not connect.", vbExclamation + vbOKOnly, _
                    MyName, vbNullString, 0)
  On Error GoTo 0
  
End Sub

Private Sub mnuFileDisconnect_Click()

  If (MSComm1.PortOpen = True) Then
    MSComm1.DTREnable = False
    MSComm1.PortOpen = False
  End If
  Me.Caption = MyName
  mnuFileConnect.Enabled = True
  mnuFileDisconnect.Enabled = False
  Timer1.Enabled = False
  Update_Display
  
End Sub

Private Sub mnuFileExit_Click()
  
  Unload Me
  
End Sub

Private Sub MSComm1_OnComm()

  If (MSComm1.InBufferCount >= 97) Then
    bs1Buffer = bs1Buffer & MSComm1.Input
  End If

End Sub

Private Sub Timer1_Timer()

  If Len(bs1Buffer) >= 97 Then
    Parse_Debug_Packet
    tempC = CSng(bs1WordRegs(0)) / 2
    tempF = tempC * 9 / 5 + 32
    Update_Display
  End If

End Sub

Private Sub Parse_Debug_Packet()
 
  Dim syncStr As String
  Dim foundSync As Long
  Dim checkLen As Long
  Dim idx As Byte
  
  syncStr = String$(17, &HF0) & String(1, &H5A)             ' create sync string
  foundSync = InStr(1, bs1Buffer, syncStr, vbTextCompare)   ' is it in the packet?

  If (foundSync > 0) Then                                   ' if > 0, yes
    checkLen = Len(bs1Buffer) - (foundSync + 18)
    ' do we have the whole packet?
    If (checkLen >= 32) Then
      bs1Buffer = Mid$(bs1Buffer, (foundSync + 18))         ' remove sync header
      bs1IORegs(0) = Asc(Mid$(bs1Buffer, 18, 1))            ' DIRS
      bs1IORegs(1) = Asc(Mid$(bs1Buffer, 17, 1))            ' PINS (out)
      bs1IORegs(2) = Asc(Mid$(bs1Buffer, 7, 1))             ' PINS (in)
      For idx = 0 To 13
        bs1ByteRegs(idx) = Asc(Mid$(bs1Buffer, (19 + idx), 1))
      Next
      For idx = 0 To 6
        bs1WordRegs(idx) = (CLng(bs1ByteRegs(idx * 2 + 1)) * 256) _
        + bs1ByteRegs(idx * 2)
      Next
      bs1Buffer = Mid$(bs1Buffer, 32)                       ' clear current debug values
    End If
  End If

End Sub

Private Sub Update_Display()

  If MSComm1.PortOpen = True Then
    lblTempC.Caption = Format(tempC, "0.0")
    lblTempF.Caption = Format(tempF, "0.0")
  Else
    lblTempC.Caption = "?"
    lblTempF.Caption = "?"
  End If

End Sub

Public Function FileExists(sFName As String) As Boolean

  If (Dir(sFName) = vbNullString) Then
    FileExists = False
  Else
    FileExists = True
  End If

End Function
